$ VERIFY_SWITCH = 'F$VERIFY(0)
$!
$! THIS PROCEDURE TAKES UP TO 4 PARAMETERS. THE FIRST PARAMETER IS
$! PASSED TO DIRECTORY. IF THE SECOND PARM CONTAINS A ".", IT IS TAKEN
$! AS THE OUTPUT FILE NAME. THE REST OF THE PARAMETERS ARE TREATED
$! AS KEYWORDS. IF A KEYWORD EQUALS "NAME", ONLY THE NAME IS OUTPUT
$! (NO $ 'P1' 'P2' 'P3') - ADDITIONALLY IF NO TARGET FILE IS SPECIFIED,
$! "X.NAX" IS USED. IF A KEYWORD EQUALS "NOV", THE VERSION NO.
$! (AND SEMICOLON) IS REMOVED FROM THE OUTPUT. CONTROL Y TERMINATES
$! AND CLOSES THE OUTPUT FILE.
$!
$ COUNT    = 1
$ NAMEFL   = 0
$ NOVFL    = 0
$ OUTFILE := X
$ IF 'F$LOCATE(".",P2)' .EQ. 'F$LENGTH(P2)' THEN GOTO LOOPPARM
$ OUTFILE :='P2'
$ COUNT    = COUNT + 1
$
$LOOPPARM:
$ COUNT    = COUNT + 1
$ IF P'COUNT .EQS. ""     THEN GOTO DOIT
$ IF P'COUNT .EQS. "NAME" THEN GOTO NAMESPEC
$ IF P'COUNT .EQS. "NOV"  THEN GOTO NOVSPEC
$ WRITE SYS$OUTPUT "Only NAME and NOV are acceptable controls."
$ goto EXIT
$
$NAMESPEC:
$ IF NAMEFL .EQ. 0 THEN GOTO NAMESPEC2
$ WRITE SYS$OUTPUT "NAME specified twice."
$ goto exit
$
$NAMESPEC2:
$ NAMEFL = 1
$ GOTO NEXTPARM
$
$NOVSPEC:
$ IF NOVFL .EQ. 0 THEN GOTO NOVSPEC2
$ WRITE SYS$OUTPUT "NOV specified twice."
$ goto EXIT
$
$NOVSPEC2:
$ NOVFL = 1
$
$NEXTPARM:
$ IF COUNT .LT. 4 THEN GOTO LOOPPARM
$
$DOIT:
$ IF OUTFILE .EQS. "X" .AND. NAMEFL .EQ. 0 THEN OUTFILE := X.COM
$ IF OUTFILE .EQS. "X" .AND. NAMEFL .NE. 0 THEN OUTFILE := X.NAX
$ DIRECTORY /COL=1 /BRIEF /NOHEADING /NOTRAILING 'P1'/OUT='OUTFILE'
$ IF $STATUS THEN GOTO OPEN
$ OPEN/WRITE OUTPUT 'OUTFILE'
$ CLOSE OUTPUT
$ GOTO EXIT
$OPEN:
$ OPEN INPUT 'OUTFILE'
$ OPEN /WRITE OUTPUT 'OUTFILE'
$ ON CONTROL_Y THEN GOTO EOF
$
$LOOP:
$ READ/END=EOF INPUT CARD
$ CARD := 'F$EXTRACT(1, 99, CARD )'	!STRIP LEADING "_"
$ LEN   = 1 + 'F$LOCATE("]", CARD )
$ CARD := 'F$EXTRACT( LEN, 99, CARD )	!STRIP DEVICE AND DIRECTORY
$ IF NOVFL .EQ. 0 THEN GOTO OUT
$ LEN   = 'F$LOCATE(";",CARD)'
$ CARD :='F$EXTRACT(0,LEN,CARD)
$
$OUT:
$ IF NAMEFL .EQ. 0 THEN CARD := "$ 'P1' 'P2' ''CARD'  'P3'"
$ WRITE OUTPUT "''CARD'"
$ GOTO LOOP
$
$EOF:
$ CLOSE INPUT
$ CLOSE OUTPUT
$ MCR FLX ='OUTFILE'/RS
$exit:
$ if verify_switch then set verify
