      PROGRAM HLP
C
C	Tree structured help facility
C
C	Stew Rubenstein, Harvard U, Sept, 1981
C
      DIMENSION KLENS(20)
      CHARACTER*20 KEYS(10), KEY, CMD
      CHARACTER*1 CMDCHR
      WRITE (*, 900)
  900 FORMAT (' Tree structured help facility'/
     1     ' Type HELP for a list of topics, or ? for help in using'/
     2     ' this program.  Questions or comments to Stew Rubenstein')
      CALL LBR$INI_CONTROL(INDEX, 1)
      CALL LBR$OPEN(INDEX, 'SYS$HELP:HELPLIB.HLB')
      KLEVEL=0
      KLENS(1)=0
    1 WRITE (*, 1000)
 1000 FORMAT ('$HELP>')
      READ (*, 1001, END=99) KLEN, CMD
 1001 FORMAT (Q, A20)
      IF (KLEN.EQ.0) GO TO 1
      CMDCHR=CMD(:1)
      KEY=CMD(2:)
      KLEN=KLEN-1
      IF (CMDCHR .EQ. '.') THEN
         KLEVEL = KLEVEL+1
      ELSE IF (CMDCHR .EQ. '^') THEN
         KLEN = 0
      ELSE IF (CMDCHR .EQ. '/') THEN
         IF (KEYS(KLEVEL)(:1) .NE. '/') KLEVEL = KLEVEL+1
         KEY = CMD
         KLEN = KLEN+1
      ELSE IF (CMDCHR .EQ. '?') THEN
         KEY = 'HLP'
         KLEN = 3
         KLEVEL = 1
      ELSE IF (CMDCHR .NE. '>') THEN
         KEY=CMD
         KLEVEL=1
         KLEN=KLEN+1
      END IF
      IF (KLEN.EQ.0) THEN
         KLEVEL = MAX(KLEVEL-1, 0)
      ELSE
         KEYS(KLEVEL) = KEY
         KLENS(KLEVEL) = KLEN
      END IF
      KLENS(KLEVEL+1) = 0
      CALL LBR$GET_HELP(INDEX,,,,
     2                  KEYS(1)(1:KLENS(1)), KEYS(2)(1:KLENS(2)),
     3                  KEYS(3)(1:KLENS(3)), KEYS(4)(1:KLENS(4)),
     4                  KEYS(5)(1:KLENS(5)), KEYS(6)(1:KLENS(6)))
      GO TO 1
   99 CALL EXIT
      END
