/*
 *===============================================
 * JPL C I/O runtime system
 * routines to handle I/O of buffered I/O files
 *
 * The routines in this file are internal to the runtime system
 * and should not be used by the application program.
 *===============================================
 */
/* no register vars until whiteshits gets the compiler going correctly ... */
#define REGIST
#include <stdio.h>
#include "[levy.c]eric.h"

extern int errno;

function _flushb(stream,c) REGIST FILE *stream; REGIST char c;
{
	REGIST int i;

	if (stream->j_count < 0) then
		stream->j_count = 0;
	fi
	i = _put(stream,stream->j_buf,BUFSIZE-stream->j_count);
	if (VMSerr(i)) then
		errno = i;
		return(EOF);
	fi
	stream->j_count = BUFSIZE;
	stream->j_ptr = stream->j_buf;
	if (c != NL) then
		*(stream->j_ptr)++ = c;
		stream->j_count--;
	fi
	return(c);
	}

function _fillb(stream) FILE *stream;
{
	REGIST int i;
	long length;

	if (feof(stream))  then
		return(EOF);
	fi
	i = _get(stream,stream->j_buf,BUFSIZE,&length);
	if (VMSerr(i)) then
		stream->j_status = FEOF;
		errno = i;
		return(EOF);
	fi
	if (length < BUFSIZE) then
		stream->j_buf[length++] = NL;
	fi
	stream->j_count = --length;
	stream->j_ptr = stream->j_buf;
	return(*(stream->j_ptr)++&0377);
	}
