#-h- spawns          4050 asc  2-oct-80 11:56:03
 include spsym

 integer function spawn(proces, args, desc, inwait)

 character proces(FILENAMESIZE), args(ARGBUFSIZE), desc(PIDSIZE),
	   inwait, wait, msg(ARGBUFSIZE), prname(20), bxname(20),
	   termnl(FILENAMESIZE), tty(FILENAMESIZE),
	   image(FILENAMESIZE), temp(FILENAMESIZE)
 character clower
 integer init, junk, i, terunt, n, boxunt, status, uic, prior,
	 stsflg, dcl, start, stop, j, inpdsc(2), outdsc(2), errdsc(2),
	 imgdsc(2), prcdsc(2), prvadr(2), unit, lpid, offset, sys$creprc
 integer trnlog, crembx, open, getpdb, equal, pwait, dclout

 include cproc
 include ctrmbx
 include cquota

 string trmbox(20) "TRMBX"
 string nuldev "NLA0:"
 string login "sys$system:loginout.exe"
 string dodcl "$@@sys_tools:dodcl/output="
 string nover "$set noverify@n"
 string ass1 "$assign/user "
 string ass2 " TT@n"

 data init/YES/
 data prvadr/-1, -1/

 if (init == YES)
    {
    init = NO
    junk = trnlog("TT", tty)		# translate to TTXn:
    for (i=1; i <= NPROCESSES; i=i+1)
	call putpdb(i)			# initialize PDB array
    n4grnd = 0				# no foreground processes
    if (crembx(trmbox, YES, termbx, terunt) == ERR)
	call error("Cannot create termination mailbox.")
    spunit = open(tty, WRITE)		# establish unit for AST writes
    if (spunit == ERR)
	call error("Cannot open tty unit for spawn AST writes.")
    call rdtmbx				# start asynch read loop of mbox
    }
 wait = clower(inwait)			# case makes no difference
 if (getpdb(offset, wait) == ERR)
    return(ERR)				# no available PDB's
 call scopy(proces, 1, pname(1,offset), 1)	# copy name into block
 call scopy(args, 1, msg, 1)		# copy arguments
 call genpnm(prname, wait, offset - NFOREGROUND)	# generate p name
 n = length(msg)
 if (n > 0)
    {
    call arggen(prname, bxname)		# generate mailbox name
    status = crembx(bxname, NO, mbxchn(offset), boxunt)
    if (status != ERR)
	{
	unit = open(bxname, WRITE)
	if (unit == ERR)
	    status = ERR
	}
    }
 else
    status = OK
 if (status != ERR)
    {
    if (wait == BACKGR)
	{
	call getuic(uic)
	prior = BACKPRIORITY
	stsflg = 64
	call scopy(nuldev, 1, termnl, 1)
	}
    else
	{
	uic = 0
	prior = FOREPRIORITY
	stsflg = 0
	call scopy(tty, 1, termnl, 1)
	}
    call scopy(proces, 1, image, 1)
    call fold(image)
    dcl = NO
    if (equal(image, "sys_tools:dcl.exe") == YES |
	equal(image, "local") == YES)
	{
	dcl = YES
	call scopy(login, 1, image, 1)
	if (n > 0)
	    {
	    i = 1
	    call stcopy(dodcl, 1, msg, i)
	    call scopy(termnl, 1, temp, 1)
	    status = dclout(args, start, stop, temp)
	    call stcopy(temp, 1, msg, i)
	    call chcopy(BLANK, msg, i)
	    if (status == YES)
		{
		for (j=1; j <= start; j=j+1)
		    call chcopy(args(j), msg, i)
		j = stop
		}
	    else
		j = 1
	    call scopy(args, j, msg, i)
	    call dscbld(inpdsc, bxname)
	    }
	else
	    call dscbld(inpdsc, nuldev)
	call dscbld(outdsc, nuldev)
	}
    else
	{
	call dscbld(inpdsc, termnl)
	call dscbld(outdsc, termnl)
	}
    call dscbld(errdsc, termnl)
    call dscbld(imgdsc, image)
    call dscbld(prcdsc, prname)
    call upper(image)
    call quotas
    call sys$setast(%val(0))		# disable AST delivery
    status = sys$creprc(lpid, imgdsc, inpdsc, outdsc, errdsc,
			prvadr, b1, prcdsc, %val(prior),
			%val(uic), %val(terunt), %val(stsflg))
    if (status != SSNORMAL)
	{
	status = ERR
	call sys$setast(%val(1))	# enable AST delivery
	}
    else
	{
	if (n > 0)
	    {
	    if (dcl == YES)
		{
		call putlin(nover, unit)
		call putlin(ass1, unit)
		call putlin(tty, unit)
		call putlin(ass2, unit)
		call putlin(msg, unit)
		call putch(NEWLINE, unit)
		}
	    else
		{
		i = IO_WRITEVBLK + IOM_NOW
		call sys$qiow(%val(1),%val(mbxchn(offset)),%val(i),,,,
			msg,%val(n),,,,)
		}
	    call close(unit)
	    }
	call puthex(lpid, desc)
	call scopy(desc, 1, pid(1,offset), 1)
	if (wait != BACKGR)
	    n4grnd = n4grnd + 1
	call sys$setast(%val(1))	# enable AST delivery
	if (wait == WAIT)
	    status = pwait(1, desc, msg, desc, ORWAIT)
	else
	    status = OK
	}
    }
 if (status == ERR)
    call putpdb(offset)
 return(status)

 end
#-h- prcdon           941 asc 23-sep-80 12:05:18
 subroutine prcdon

 integer ptr, j, equal
 character buf(PIDSIZE)

 include cproc
 include ctrmbx

 ptr = 0
 call puthex(iosb(2), buf)
 for (j=1; j <= NPROCESSES & ptr == 0; j=j+1)
    if (equal(pid(1,j), buf) == YES)
	ptr = j
 if (ptr != 0)
    {
    pdone(ptr) = YES
    for (j=1; j <= TERMSGSIZE; j=j+1)
	pmsg(j, ptr) = termsg(j)
    if (ptr <= NFOREGROUND & n4grnd > 0)
	n4grnd = n4grnd - 1
    }
 if (n4grnd <= 0)
    for (j=NFOREGROUND+1; j <= NPROCESSES; j=j+1)
	if (pdone(j) == YES & pid(1,j) != EOS)
	    {
	    call putlin("background process ", spunit)
	    call putlin(pid(1, j), spunit)
	    call putlin(" terminated", spunit)
	    if (.not. pmsg(2,j) & pmsg(2,j) != 0)
		{
		call putlin(" abnormally. Return status = ", spunit)
		call puthex(pmsg(2,j), buf)
		call putlin(buf, spunit)
		}
	    else
		call putlin(" successfully.", spunit)
	    call putch(NEWLINE, spunit)
	    call putpdb(j)
	    }
 call rdtmbx

 return
 end
#-h- rdtmbx           160 asc 23-sep-80 12:05:19
 subroutine rdtmbx

 include ctrmbx

 external prcdon

 call sys$qio(,%val(termbx),%val(READVBLK),iosb,prcdon,,termsg,
	%val(TERMSGSIZEBYTE),,,,)

 return
 end
#-h- quotas           655 asc 23-sep-80 12:05:19
 subroutine quotas(wait)

 integer fillm, mul, fillma
 integer*2 qlist(8)
 character wait
 equivalence (fillma,qlist(3))

 include cquota

 data  qlist/4,JPIFILLM,4*0,2*0/
 
 b1 = pqlastlm
 l1 = ASTLM
 b2 = pqlbiolm
 l2 = BIOLM
 b3 = pqlbytlm
 b4 = pqlcpulm
 l4 = CPULM
 b5 = pqldiolm
 l5 = DIOLM
 b6 = pqlfillm
 b7 = pqlpgflquota
 b8 = pqlprclm
 b9 = pqltqelm
 ba = pqlwsquota
 la = WSQUOTA
 bb = pqlwsdefault
 lb = WSDEFAULT
 b0 = pqllistend

 fillma = %loc(fillm)
 call sys$getjpi(,,,qlist,,,)
 mul = fillm / FILLM
 if (mul > 1)
	mul = mul - 1
 l3 = mul * BYTLM
 l6 = mul * FILLM
 l7 = mul * PGFLQUOTA
 l8 = mul * PRCLM
 l9 = mul * TQELM

 return
 end
#-h- unique           120 asc 23-sep-80 12:05:20
 subroutine unique(buf)

 character buf(ARB)
 integer mypid

 call getpid(mypid)
 call puthex(mypid, buf)

 return
 end
#-h- puthex           234 asc 23-sep-80 12:23:12
 subroutine puthex(n, buf)

 integer n, fmt(2), out(2)
 character buf(ARB)

 string fmtbuf "!XL"

 call dscbld(fmt, fmtbuf)
 out(1) = 9
 out(2) = %loc(buf)
 call sys$fao(fmt,, out, %val(n))
 buf(9) = EOS
 call fold(buf)

 return
 end
#-h- getmsg           826 asc 23-sep-80 12:05:21
 integer function getmsg(buf)

 integer done, i, junk, int
 integer length, getdcl, open, getlin, trnlog, equal
 character buf(ARGBUFSIZE), pname(20), bname(20)

 string dummy "* "
 string dcltools "DCL_TOOLS"

 data done/NO/

 if (done == YES)
    {
    call scopy(dummy, 1, buf, 1)
    return(length(buf))
    }
 done = YES
 call getpnm(pname)		# get our process name
 junk = trnlog(dcltools, buf)	# see if invoked from DCL
 if (pname(1) != DOLLAR | equal(dcltools, buf) == NO)
    {
    i = 1
    call stcopy(dummy, 1, buf, i)
    junk = getdcl(buf(i))
    }
 else
    {
    call arggen(pname, bname)	# generate mailbox name
    int = open(bname, READ)	# open for reading
    if (int == ERR)
	call scopy(dummy, 1, buf, 1)
    else
	{
	i = getlin(buf, int)
	call close(int)
	buf(i) = EOS
	}
    }
 return(length(buf))

 end
#-h- crembx           832 asc 23-sep-80 12:05:22
 integer function crembx(buf, uniqit, descr, unit)

 character buf(ARB), unqbuf(20), name(64)
 integer*4 descr, status, sys$crembx, init, i, length, sys$getchn, uniqit
 integer lognm(2)
 integer*2 unit, chunit
 equivalence (chunit, name(13))

 data init/0/

 if (init == 0)
    {
    call unique(unqbuf)
    init = 1
    }
 i = 1
 call stcopy(buf, 1, name, i)
 if (uniqit == YES)
    call stcopy(unqbuf, 1, name, i)
 name(i) = EOS
 call upper(name)
 call dscbld(lognm, name)
 status = sys$crembx(,descr,%val(512),,%val(0),,lognm)
 if (status != SSNORMAL & status != SSSUPERCEDE)
    crembx = ERR
 else
    {
    call scopy(name, 1, buf, 1)
    lognm(1) = 64
    status = sys$getchn(%val(descr),,lognm,,)
    if (status != SSNORMAL & status != SSBUFFEROVF)
	crembx = ERR
    else
	{
	unit = chunit
	crembx = OK
	}
    }
 return
 end
#-h- trnlog           536 asc 23-sep-80 12:05:23
 integer function trnlog(in, out)
 
 character buf1(64), buf2(64), in(100), out(100)
 integer status, sys$trnlog, length, d1(2), d2(2), n
 
 d1(2) = %loc(buf1)
 d2(2) = %loc(buf2)
 call scopy(in, 1, buf1, 1)
 d1(1) = length(in)
 
 repeat
    {
    d2(1) = 64
    status = sys$trnlog(d1, n, d2,,, %val(0))
    buf2(n+1) = 0
    if (buf2(1) == 27)
	{
	n = n - 4
	call scopy(buf2, 5, buf2, 1)
	}
    d1(1) = n
    call scopy(buf2, 1, buf1, 1)
    }
 until (status == SSNOTRAN)
 
 trnlog = d1(1)
 call scopy(buf1, 1, out, 1)
 
 return
 end
#-h- getuic           193 asc 23-sep-80 12:05:24
 subroutine getuic(uic)

 integer*4 uic, uica
 integer*2 jpibuf(8)

 equivalence (jpibuf(3), uica)

 data jpibuf/4, JPIUIC, 6*0/

 uica = %loc(uic)
 call sys$getjpi(,,,jpibuf,,,)

 return
 end
#-h- genpnm          1095  asc  30-oct-80 13:57:31  tools
 subroutine genpnm(proces, wait, offset)

 character wait, base(20), level(4), c, proces(ARB)
 character type
 integer n, i, j, junk
 integer index, ctoi, itoc, length

 string l1 ".1"

 call getpnm(proces)		# get this process's name
 if (proces(1) == DOLLAR)	# spawned by a tool?
    {
    n = index(proces, PERIOD)	# find separator
    if (n > 0)
	{
	i = n + 1
	j = ctoi(proces, i) + 1
	level(1) = PERIOD
	junk = itoc(j, level(2), 3)
	proces(n) = EOS
	}
    else
	call scopy(l1, 1, level, 1)
    call scopy(proces, 1, base, 1)
    }
 else
    {
    base(1) = DOLLAR
    j = 2
    for (i=1; proces(i) != EOS; i=i+1)
	{
	c = type(proces(i))
	if (c == LETTER | c == DIGIT)
	    {
	    base(j) = proces(i)
	    j = j + 1
	    }
	}
    base(j) = EOS
    n = length(base)
    if (n > 8)			# must truncate to 8 unique characters
	call scopy(base, n-6, base, 2)
    call scopy(l1, 1, level, 1)
    }
 i = 1
 call stcopy(base, 1, proces, i)
 if (wait == BACKGR)
    {
    call chcopy(AMPER, proces, i)
    junk = itoc(offset, proces(i), 3)
    }
 else
    call scopy(level, 1, proces, i)

 return
 end
#-h- arggen           357 asc 23-sep-80 12:06:00
 subroutine arggen(pname, bname)

 character pname(ARB), bname(ARB)
 integer i, j

 string argstr "arg"

 j = 1
 call stcopy(argstr, 1, bname, j)
 for (i=1; pname(i) != EOS; i=i+1)
    if (pname(i) == AMPER)
	call chcopy(UNDERLINE, bname, j)
    else if (pname(i) != PERIOD)
	call chcopy(pname(i), bname, j)
 bname(j) = EOS
 call upper(bname)

 return
 end
#-h- putpdb           255 asc  2-oct-80 11:56:07
 subroutine putpdb(offset)

 integer offset

 include cproc

 call sys$setast(%val(0))		# disable AST delivery
 pid(1, offset) = EOS
 pdone(offset) = NO
 call sys$dassgn(%val(mbxchn(offset)))
 call sys$setast(%val(1))		# enable AST delivery

 return
 end
#-h- getpdb           674 asc 23-sep-80 13:52:22
 integer function getpdb(offset, wait)

 integer offset, start, stop, init, mypid, ownpid
 character wait

 include cproc

 data init/YES/

 if (init == YES)
    {
    call getpid(mypid)
    call getown(mypid, ownpid)
    init = NO
    }
 if (wait == BACKGR)
    {
    start = NFOREGROUND + 1
    if (ownpid == 0)
	stop = NPROCESSES
    else
	stop = start - 1
    }
 else
    {
    start = 1
    stop = NFOREGROUND
    }
 call sys$setast(%val(0))		# disable AST delivery
 for (offset = start; offset <= stop & pid(1,offset) != EOS; offset=offset+1) ;
 call sys$setast(%val(1))		# enable AST delivery
 if (offset <= stop)
    getpdb = OK
 else
    getpdb = ERR

 return
 end
#-h- pwait            545 asc 23-sep-80 12:09:37
 integer function pwait(nprocs, pids, pinfo, lstpid, flag)

 integer nprocs, pinfo(TERMSGSIZE, ARB), flag, i, j, k, equal
 character pids(PIDSIZE, ARB), lstpid(PIDSIZE)

 include cproc

 for (i=1; i <= nprocs; i=i+1)
    {
    for (j=1; j <= NFOREGROUND & equal(pid(1,j),pids(1,i)) == NO; j=j+1) ;
    if (j > NFOREGROUND)
	next
    while (pdone(j) != YES)
	call wtmsec(100)		# wait 100 msec
    for (k=1; k <= TERMSGSIZE; k=k+1)
	pinfo(k,i) = pmsg(k,j)
    call scopy(pids(1,i), 1, lstpid, 1)
    call putpdb(j)
    }
 pwait = OK

 return
 end
#-h- wtmsec           313 asc 23-sep-80 12:09:37
 subroutine wtmsec(n)

 define(MILLISECOND,-10000)
 define(TIMEFLAG,10)
 define(MAXMILLISECONDS,1000)

 integer n, m, systim(2)

 data systim(2)/-1/

 m = max(n, 1)
 m = min(m, MAXMILLISECONDS)
 systim(1) = m * MILLISECOND
 call sys$setimr(%val(TIMEFLAG), systim,,)
 call sys$waitfr(%val(TIMEFLAG))

 return
 end
#-h- dclout           644 asc 23-sep-80 12:09:38
 integer function dclout(lin, start, stop, args)

 character lin(ARB), args(ARB), qchar
 integer i, j, start, stop, junk, getwrd

 for (i=1; lin(i) != NEWLINE & lin(i) != EOS; i=i+1)
    if (lin(i) == BLANK)
	{
	call skipbl(lin, i)
	if (lin(i) == GREATER)
	    {
	    start = i - 1
	    for ( ; lin(i) == GREATER; i=i+1)
		;
	    junk = getwrd(lin, i, args)
	    stop = i
	    dclout = YES
	    return
	    }
	i = i - 1
	}
    else if (lin(i) == SQUOTE | lin(i) == DQUOTE)
	{
	qchar = lin(i)
	for (i=i+1; lin(i) != qchar & lin(i) != NEWLINE & lin(i) != EOS;
	    i=i+1)
	    ;
	if (lin(i) != qchar)
	    i = i - 1
	}
 dclout = NO

 return
 end
#-h- enbint           737 asc 23-sep-80 12:09:39
 define(IOCTRLCAST,291)		# '123'x  io$_setmode!io$m_ctrlcast

 subroutine enbint

 character buf(FILENAMESIZE)
 integer sys$assign, sys$qiow, dsc(2), chan, init, trnlog, junk, ownid, tty,
	intok, mypid
 external intsrv

 data init/YES/

 if (init == YES)
    {
    call getpid(mypid)
    call getown(mypid, ownid)
    init = NO
    if (tty(STDIN) == YES & ownid == 0)
	intok = YES
    else
	intok = NO
    if (intok == YES)
	{
	junk = trnlog("SYS$INPUT", buf)
	call dscbld(dsc, buf)
	if (.not. sys$assign(dsc, chan,,))
            call error("Cannot assign channel for interrupts")
	}
    }
 if (intok == YES)
    if (.not. sys$qiow(, %val(chan), %val(IOCTRLCAST),,,,intsrv,,,,,))
	call error("Cannot enable ^C interrupt")

 return
 end
#-h- intsrv           188 asc 23-sep-80 12:14:37
 subroutine intsrv

 integer i, junk, kill

 include cproc

 for (i=1; i <= NFOREGROUND; i=i+1)
    if (pid(1,i) != EOS & pdone(i) == NO)
	junk = kill(pid(1,i))
 call enbint

 return
 end
#-h- dscbld           143 asc 23-sep-80 12:14:38
 subroutine dscbld(dsc, string)

 integer dsc(2), length
 character string(ARB)

 dsc(1) = length(string)
 dsc(2) = %loc(string)

 return
 end
#-h- kill             206 asc 23-sep-80 12:14:38
 integer function kill(buf)

 character buf(PIDSIZE)
 integer pid, sys$forcex, status, htoi

 pid = htoi(buf)
 status = sys$forcex(pid,,)
 if (.not. status)
    kill = ERR
 else
    kill = OK

 return
 end
#-h- htoi             260 asc 23-sep-80 12:14:38
 integer function htoi(buf)

 character buf(ARB), temp(PIDSIZE)
 integer n, length, int

 call scopy(buf, 1, temp, 1)
 call upper(temp)
 n = length(temp)
 if (.not. lib$cvt_htb(%val(n), %ref(temp), %ref(int)))
    htoi = ERR
 else
    htoi = int

 return
 end
#-h- exppid           139 asc 23-sep-80 12:14:38
 subroutine exppid(in, out)

 character in(PIDSIZE), out(PIDSIZE)
 integer pid, htoi

 pid = htoi(in)
 call puthex(pid, out)

 return
 end
#-h- getown           175 asc 23-sep-80 12:14:39
 subroutine getown(mypid, ownid)

 integer ownid, mypid

 jpilst(owner)

 data owner/4, JPIOWNER, 6*0/

 ownera = %loc(ownid)
 call sys$getjpi(,mypid,,owner,,,)

 return
 end
#-h- getpid           144 asc 23-sep-80 12:14:39
 subroutine getpid(pid)

 integer pid

 jpilst(list)

 data list/4, JPIPID, 6*0/

 lista = %loc(pid)
 call sys$getjpi(,,,list,,,)

 return
 end
#-h- getpnm           380 asc 23-sep-80 12:14:39
 define(JPIPRCNAM,796)

 subroutine getpnm(proces)

 character proces(ARB), local(16)
 integer*2 jpibuf(8), length
 integer addr, leng

 equivalence (addr,jpibuf(3)), (leng, jpibuf(5))

 data jpibuf/15, JPIPRCNAM, 6*0/

 addr = %loc(local)
 leng = %loc(length)
 call sys$getjpi(,,,jpibuf,,,)
 local(length+1) = EOS
 call fold(local)
 call scopy(local, 1, proces, 1)

 return
 end
#-h- pstat            374 asc  6-oct-80 13:35:50
 define(JPISTATE,774)		# '306'x

 integer function pstat(buf)

 character buf(PIDSIZE)
 integer pid, sys$getjpi, status, state, astate, htoi
 integer*2 jpibuf(8)

 equivalence (astate, jpibuf(3))

 data jpibuf/4,JPISTATE,6*0/

 astate = %loc(state)
 pid = htoi(buf)
 status = sys$getjpi(,pid,,jpibuf,,,)
 if (.not. status)
    pstat = ERR
 else
    pstat = OK

 return
 end
#-h- suspnd           211 asc  6-oct-80 13:35:51
 integer function suspnd(buf)

 character buf(PIDSIZE)
 integer pid, sys$suspnd, status, htoi

 pid = htoi(buf)
 status = sys$suspnd(pid,)
 if (.not. status)
    suspnd = ERR
 else
    suspnd = OK

 return
 end
#-h- resume           211 asc  6-oct-80 13:35:51
 integer function resume(buf)

 character buf(PIDSIZE)
 integer pid, sys$resume, status, htoi

 pid = htoi(buf)
 status = sys$resume(pid,)
 if (.not. status)
    resume = ERR
 else
    resume = OK

 return
 end
