 include spsym

 integer function spawn(proces, args, desc, inwait)

 character proces(FILENAMESIZE), args(ARGBUFSIZE), desc(PIDSIZE),
	   inwait, wait, msg(ARGBUFSIZE), prname(20), bxname(20),
	   termnl(FILENAMESIZE), tty(FILENAMESIZE),
	   image(FILENAMESIZE), temp(FILENAMESIZE)
 character clower
 integer init, junk, i, terunt, n, boxunt, status, uic, prior,
	 stsflg, dcl, start, stop, j, inpdsc(2), outdsc(2), errdsc(2),
	 imgdsc(2), prcdsc(2), prvadr(2), unit, lpid, offset, sys$creprc
 integer trnlog, crembx, open, getpdb, equal, pwait, dclout

 include "[tools]cproc"
 include "[tools]ctrmbx"
 include "[tools]cquota"

 string trmbox(20) "TRMBX"
 string nuldev "NLA0:"
 string login "sys$system:loginout.exe"
 string dodcl "$@@dr:[levy.test]dodcled/output="
 string nover "$set noverify@n"
 string ass1 "$assign/user "
 string ass2 " TT@n"

 data init/YES/
 data prvadr/-1, -1/

 if (init == YES)
    {
    init = NO
    junk = trnlog("TT", tty)		# translate to TTXn:
    for (i=1; i <= NPROCESSES; i=i+1)
	call putpdb(i)			# initialize PDB array
    n4grnd = 0				# no foreground processes
    if (crembx(trmbox, YES, termbx, terunt) == ERR)
	call error("Cannot create termination mailbox.")
    spunit = open(tty, WRITE)		# establish unit for AST writes
    if (spunit == ERR)
	call error("Cannot open tty unit for spawn AST writes.")
    call rdtmbx				# start asynch read loop of mbox
    }
 wait = clower(inwait)			# case makes no difference
 if (getpdb(offset, wait) == ERR)
    return(ERR)				# no available PDB's
 call scopy(proces, 1, pname(1,offset), 1)	# copy name into block
 call scopy(args, 1, msg, 1)		# copy arguments
 call genpnm(prname, wait, offset - NFOREGROUND)	# generate p name
 n = length(msg)
 if (n > 0)
    {
    call arggen(prname, bxname)		# generate mailbox name
    status = crembx(bxname, NO, mbxchn(offset), boxunt)
    if (status != ERR)
	{
	unit = open(bxname, WRITE)
	if (unit == ERR)
	    status = ERR
	}
    }
 else
    status = OK
 if (status != ERR)
    {
    if (wait == BACKGR)
	{
	call getuic(uic)
	prior = BACKPRIORITY
	stsflg = 64
	call scopy(nuldev, 1, termnl, 1)
	}
    else
	{
	uic = 0
	prior = FOREPRIORITY
	stsflg = 0
	call scopy(tty, 1, termnl, 1)
	}
    call scopy(proces, 1, image, 1)
    call fold(image)
    dcl = NO
    if (equal(image, "sys_tools:dcl.exe") == YES |
	equal(image, "local") == YES)
	{
	dcl = YES
	call scopy(login, 1, image, 1)
	if (n > 0)
	    {
	    i = 1
	    call stcopy(dodcl, 1, msg, i)
	    call scopy(termnl, 1, temp, 1)
	    status = dclout(args, start, stop, temp)
	    call stcopy(temp, 1, msg, i)
	    call chcopy(BLANK, msg, i)
	    if (status == YES)
		{
		for (j=1; j <= start; j=j+1)
		    call chcopy(args(j), msg, i)
		j = stop
		}
	    else
		j = 1
	    call scopy(args, j, msg, i)
	    call dscbld(inpdsc, bxname)
	    }
	else
	    call dscbld(inpdsc, nuldev)
	call dscbld(outdsc, nuldev)
	}
    else
	{
	call dscbld(inpdsc, termnl)
	call dscbld(outdsc, termnl)
	}
    call dscbld(errdsc, termnl)
    call dscbld(imgdsc, image)
    call dscbld(prcdsc, prname)
    call upper(image)
    call quotas
    call sys$setast(%val(0))		# disable AST delivery
    status = sys$creprc(lpid, imgdsc, inpdsc, outdsc, errdsc,
			prvadr, b1, prcdsc, %val(prior),
			%val(uic), %val(terunt), %val(stsflg))
    if (status != SSNORMAL)
	{
	status = ERR
	call sys$setast(%val(1))	# enable AST delivery
	}
    else
	{
	if (n > 0)
	    {
	    if (dcl == YES)
		{
		call putlin(nover, unit)
		call putlin(ass1, unit)
		call putlin(tty, unit)
		call putlin(ass2, unit)
		call putlin(msg, unit)
		call putch(NEWLINE, unit)
		}
	    else
		{
		i = IO_WRITEVBLK + IOM_NOW
		call sys$qiow(%val(1),%val(mbxchn(offset)),%val(i),,,,
			msg,%val(n),,,,)
		}
	    call close(unit)
	    }
	call puthex(lpid, desc)
	call scopy(desc, 1, pid(1,offset), 1)
	if (wait != BACKGR)
	    n4grnd = n4grnd + 1
	call sys$setast(%val(1))	# enable AST delivery
	if (wait == WAIT)
	    status = pwait(1, desc, msg, desc, ORWAIT)
	else
	    status = OK
	}
    }
 if (status == ERR)
    call putpdb(offset)
 return(status)

 end
