C       Start of include file DMPRES.FOR
C
C       Common block for DUMPER program RESTORE command
C
C       RESMAX   -- Number of restore commands allowed
C       TAPEMAX  -- Number of filespec parts on the tape
C       RESCNT   -- Current index into restore tables
C       VAXDIR   -- Directories to restore to
C       VAXLEN   -- Length of VAXDIR entry
C       TAPENAME -- DEC 10/20 filespec parts in order
C       (1=UFD, 2 to TAPEMAX-2=SFD, TAPEMAX-1=FILE,TAPEMAX=EXT)
C       TAPELEN  -- Length of corresponding TAPENAME entry
C       VALIDF   -- Valid file table.  If .TRUE., then the
C       corresponding name is still valid (so far).
C       VALIDD   -- Valid directory table.  If .TRUE., then
C       the corresponding directory name is still ok.
C       NVDIR    -- If .TRUE., then no directories are valid.
C       CURDIR   -- Current directory name.
C       CDIRLEN  -- Length of current directory name (0 if none).
C	STNAME   -- Selected tape name
C	STEXT    -- Selected extension
C	STNLEN   -- Selected Name Length
C	STELEN   -- Selected Extension Length
C
	INTEGER*4 RESMAX,TAPEMAX,RESCNT,VAXLEN,TAPELEN,TAPECNT
	LOGICAL VALIDF,VALIDD,NVDIR
	INTEGER*4 CDIRLEN,STNLEN,STELEN
	PARAMETER (RESMAX=100,TAPEMAX=8)
	DIMENSION VAXLEN(RESMAX),TAPELEN(TAPEMAX,RESMAX)
	DIMENSION VALIDF(RESMAX),VALIDD(RESMAX)
	COMMON /RESCOM/ RESCNT,TAPECNT,VAXLEN,TAPELEN
	1 ,VALIDF,VALIDD,CDIRLEN,NVDIR,STNLEN,STELEN
C
	CHARACTER*64 VAXDIR(RESMAX)
	CHARACTER*32 TAPENAME(TAPEMAX,RESMAX)
	CHARACTER*256 CURDIR
	CHARACTER*9 STNAME
	CHARACTER*3 STEXT
	COMMON /RESCOMC/ VAXDIR,TAPENAME,CURDIR,STNAME,STEXT
C
C       End of include file DMPCOM.FOR
