	PROGRAM NAIL
C
C	A program to remove users from the system in a
C	more gracefull way than just nailing them.
C
	CHARACTER*8 PROCID
	INTEGER*4 PROCLEN
	INTEGER*4 PROCESS
	INTEGER*4 JPIB4(13)
	INTEGER*2 JPIB2(26)
	EQUIVALENCE (JPIB2,JPIB4)
	CHARACTER*12 USERNAME
	INTEGER*4 UIC
	CHARACTER*7 TERMINAL
	CHARACTER*64 IMAGE
	INTEGER*4 USERLEN,TERMLEN,IMAGELEN
	INTEGER*4 STATUS
	INTEGER*2 IOSB(4)
C
C	External definitions for calling SYS$GETJPI and
C	other system services.
C
	INTEGER*4 SYS$GETJPI,SYS$WAITFR,LIB$GET_FOREIGN
	EXTERNAL JPI$_UIC,JPI$_USERNAME,JPI$_TERMINAL,JPI$_IMAGNAME
C
C	Initialize the data block needed for SYS$GETJPI
C
	JPIB2(1) = 4
	JPIB2(2) = %LOC(JPI$_UIC)
	JPIB4(2) = %LOC(UIC)
	JPIB4(3) = 0
C
	JPIB2(7) = 12
	JPIB2(8) = %LOC(JPI$_USERNAME)
	JPIB4(5) = %LOC(USERNAME)
	JPIB4(6) = %LOC(USERLEN)
C
	JPIB2(13) = 7
	JPIB2(14) = %LOC(JPI$_TERMINAL)
	JPIB4(8) = %LOC(TERMINAL)
	JPIB4(9) = %LOC(TERMLEN)
C
	JPIB2(19) = 64
	JPIB2(20) = %LOC(JPI$_IMAGNAME)
	JPIB4(11) = %LOC(IMAGE)
	JPIB4(12) = %LOC(IMAGELEN)
C
	JPIB4(13) = 0
C
C	Find out what process ID is to be analyzed
C
10	CONTINUE
	STATUS = LIB$GET_FOREIGN(PROCID,'Process ID:  ',PROCLEN)
	READ(PROCID(1:PROCLEN),20) PROCESS
20	FORMAT(Z<PROCLEN>)
	IF (PROCESS.EQ.0) THEN
	 WRITE(*,30) PROCESS
30	FORMAT(1X,Z8.8' is not a valid process id')
	 GOTO 2000
	ENDIF
C
	STATUS = SYS$GETJPI(,PROCESS,,JPIB2,IOSB,,)
	IF (.NOT.STATUS) THEN
	 WRITE(*,30) PROCESS
	 CALL ERRORM(STATUS)
	 GOTO 2000
	ENDIF
	STATUS = SYS$WAITFR(%VAL(0))
	IF (.NOT.STATUS) THEN
	 WRITE(*,30) PROCESS
	 CALL ERRORM(STATUS)
	 GOTO 2000
	ENDIF
C
C	Now that the information has been gathered, let us
C	check some 'critical' parameters before something
C	rash is done to the user.
C
	IF (UIC.LT.'80000'X) THEN
	 WRITE(*,40) UIC/'10000'X,MOD(UIC,'10000'X)
40	FORMAT(' You cannot NAIL a system UIC like [',O3.3,',',O3.3']')
	 GOTO 2000
	ENDIF
C
C	Now finally, let us attempt to get that user!
C
100	CONTINUE
	OPEN(UNIT=1,NAME='NAIL.COM',CARRIAGECONTROL='LIST',
	1 STATUS='NEW',ERR=200)
	WRITE(1,110) PROCESS,TERMINAL(1:TERMLEN),PROCESS,
	1 USERNAME(1:USERLEN),
	1 UIC/'10000'X,MOD(UIC,'10000'X),IMAGE(1:IMAGELEN)
110	FORMAT('$SET NOON',/,
	1 '$SET PROC/PRIO=4/ID=',Z8.8,/,
	2 '$REP/BELL "You will be logged out in 1 minute"/TERM=',A,/
	3 '$WAIT 0:1:0.0',/,
	4 '$STOP/ID=',Z8.8,/,
	5 '$REQUEST/TO=CENTRAL "',A,' [',O3.3,',',O3.3,'] has been',
	5 ' logged out, was running"',/,
	6 '$REQUEST/TO=CENTRAL "',A,'"',/,
	7 '$DELETE NAIL.COM;*',/,
	8 '$STOP/ID=0')
	CLOSE(UNIT=1)
	CALL LIB$DO_COMMAND('$RUN/UIC=[2,2]/INP=NAIL.COM'//
	1 '/OUT=NL:/ERR=NL:/PRIO=16/NOAUTH SYS:LOGINOUT')
200	CONTINUE
	WRITE(*,210)
210	FORMAT(' Error creating NAIL.COM')
C
2000	CONTINUE
	END
