
{
     Define the Global Section Structure
						}

  sts    = (idle, waiting, plotting, stopped, print_mode, pxx1, pxx2, pxx3);
  chs    = (printer_attached, no_printer, unknown, px1, px2, px3, px4, px5);
  stset  = PACKED SET OF sts;
  chset  = PACKED SET OF chs;

  mttype = PACKED RECORD
	link:longword;
	fill:PACKED ARRAY [1..14] OF INTEGER;
	idtag:alfa4;
	END;

  fdtype = PACKED RECORD
	link:longword;
	device:alfa4;
	dlen,flen:byte;
	dir_name:alfa33;
	f_name:alfa17;
	idtag:alfa4;
	END;

  jhtype = PACKED RECORD
	link:longword;
	user_name:alfa12;
	uic,pid:longword;
	entry_time,start_time:quadword;
	hold_flag,no_delete,priority,working:byte;
	vec_link,parm_link:longword;
	entry_no:longword;
	notify,padb1,padb2,padb3:byte;
	idtag:alfa4;
	END;

  various = PACKED RECORD
	CASE INTEGER OF
	  1:(job_head:jhtype);
	  2:(file_descr:fdtype);
	  3:(srpls:mttype)
	END;

  qht = PACKED RECORD
	link:INTEGER;
	device_name:alfa4;
	link1:longword;
	status:stset;
	entries:byte;
	characteristics:chset;
	lnlen:byte;
	lqname:alfa12;
	sub_proc:longword;
	rest:PACKED ARRAY [1..7] OF INTEGER;
	idtag:alfa4;
	END;

  ctrl = PACKED RECORD
	flhead:INTEGER;
	nques:byte;
	flen:PACKED ARRAY [1..7] OF byte;
	qname:PACKED ARRAY [1..7] OF alfa4;
	last_jobno:INTEGER;
	pad4l:PACKED ARRAY [1..4] OF longword;
	idtag:alfa4;
	END;

  secptr = ^sectiont;

  sectiont = PACKED RECORD
	control:ctrl;
	qhead:PACKED ARRAY [1.. 7] OF qht;
	qinfo:PACKED ARRAY [1..152] OF various;
	END;

