	PROGRAM DETAB

	IMPLICIT INTEGER (A-Z)

	INCLUDE 'STATUS.INC'
	INCLUDE 'CLI.INC'
	INCLUDE 'BUFFER.INC'
	INCLUDE 'RMSDATA.INC'

	EXTERNAL OPEN_ERROR
	EXTERNAL FILE_ACTION_ROUTINE
	EXTERNAL DETAB_SUCCESS
	EXTERNAL DETAB_EXCEPTION

	WORST_ERROR = %LOC(DETAB_SUCCESS)

	FORCED_EXIT = 0

	CALL BUILD_RMS_DATA_STRUCTURES

	CALL LIB$ESTABLISH(DETAB_EXCEPTION)

	CALL SYS$CLI
	1    (%VAL(REQUEST(INITIALIZE_PARSE)),
	2     WORK_AREA,
	3     DETAB_STATUS)

	CALL SYS$CLI
	1    (%VAL(REQUEST(PARSE_COMMAND)),
	2     WORK_AREA,
	3     DETAB_STATUS)

	CALL SYS$CLI
	1    (%VAL(REQUEST(PARSE_COMMAND_QUALIFIERS)),
	2     WORK_AREA,
	3     DETAB_STATUS)

	CALL SYS$CLI
	1    (%VAL(REQUEST(GET_OUTPUT_FILE_NAME)),
	2     WORK_AREA,
	3     DETAB_STATUS)

	CALL SYS$CLI
	1    (%VAL(REQUEST(END_OUTPUT_FILE_NAME)),
	2     WORK_AREA,
	3     DETAB_STATUS)

	CALL SYS$CLI
	1    (%VAL(REQUEST(GET_INPUT_FILE_NAME)),
	2     WORK_AREA,
	3     DETAB_STATUS)


	DO WHILE((FORCED_EXIT .AND.
	1        (DETAB_M_ERROR .OR. DETAB_M_DONE)) .EQ. 0)

	  CALL FMG$FILE_SCAN(INPUT_FAB,
	1                    FILE_ACTION_ROUTINE,
	2                    OPEN_ERROR)

	  CALL SYS$CLI
	1      (%VAL(REQUEST(GET_INPUT_FILE_NAME)),
	2       WORK_AREA,
	3       DETAB_STATUS)

	END DO

	  CALL SYS$CLI
	1      (%VAL(REQUEST(END_INPUT_FILE_NAME)),
	2       WORK_AREA,
	3       DETAB_STATUS)

	CALL SYS$EXIT(%VAL(WORST_ERROR))

	END
