C
C	STATUS.INC
C
C	THIS FILE DEFINES STATUS AREA FOR DCL LIST COMMAND.
C

C
C	DEFINE BIT VALUES AND MASKS FOR LOCAL_STATUS.
C
C	NOTE: THAT THE VALUES OF THE FOLLOWING PARAMETERS ARE ESTAB-
C	LISHED IN CLIREQ.MAR.
C

	PARAMETER LIST_V_LINE		= 0	! INDICATES /LINE_NUMBERS SEEN
	PARAMETER LIST_M_LINE		= 1	! CORRESPONDING MASK
	PARAMETER LIST_V_INDEX		= 1	! INDICATES /INDEX SEEN
	PARAMETER LIST_M_INDEX		= 2	! CORRESPONDING MASK
	PARAMETER LIST_V_OUTPUT		= 2	! INDICATES /OUTPUT SEEN
	PARAMETER LIST_M_OUTPUT		= 4	! CORRESPONDING MASK
	PARAMETER LIST_V_PRINTER	= 3	! INDICATES /PRINTER SEEN
	PARAMETER LIST_M_PRINTER	= 8	! CORRESPONDING MASK
	PARAMETER LIST_V_DONE		= 31	! INDICATES END OF P1
	PARAMETER LIST_M_DONE		= '80000000'X ! CORRESPONDING MASK

	INTEGER*4 WORST_ERROR,			! RECORDS MOST SEVER ERROR ENCOUNTERED
	1         LIST_STATUS,			! PARSE STATUS
	2         CURRENT_PAGE,			! CURRENT LISTING PAGE
	3         CURRENT_LINE			! LINE WITHIN CURRENT PAGE

	COMMON /STATUS_AREA/ WORST_ERROR, LIST_STATUS, CURRENT_PAGE,
	1                    CURRENT_LINE

