	PROGRAM D1640INIT
C
C	THIS PROGRAM ALLOWS THE USER TO INITIALIZE THE POOR
C	DIABLO 1640 PRINTER @ HMC WHICH HAS NO KEYBOARD TO
C	DRIVE IT....  USER INPUTS INCLUDE SETTING ELITE/PICA SPACING
C	PAGE LENGTH, AND PAGE WIDTH.
C
	INTEGER*2 RPM,LPM,TPL
	INTEGER*2 NLINES,NCOLS,LPI,CPI,MAXCOL
	INTEGER*2 I,J
	CHARACTER*6 TNAM
	INTEGER*2 TLEN,TCHAN
	CHARACTER*1 ANS
	BYTE INIT(50)
	BYTE BUF(100)
C
C	External functions
C
	INTEGER*4 SYS$ASSIGN,SYS$DASSGN
	INTEGER*4 TERMOUT
C
C	Initial data settings
C
	DATA INIT/27,13,80,41*0,27,31,11,27,30,7/
C
C	Initialize the program
C
5	CONTINUE
	TYPE 10
10	FORMAT(' Diablo 1640 Printer Initialization Program',/,
	1 ' Version 1.0',/,
	2 ' Which terminal do you wish to set up?  ',$)
	ACCEPT 20,TLEN,TNAM
20	FORMAT(Q,A)
	CALL STR$UPCASE(TNAM,TNAM)
	IF ((TLEN.GT.6).OR.(TLEN.EQ.0)) GOTO 5
	I = SYS$ASSIGN(%DESCR(TNAM(1:TLEN)),%REF(TCHAN),,)
	IF (.NOT.I) CALL LIB$SIGNAL(I)
C
25	CONTINUE
	TYPE 30
30	FORMAT(' Are you using an ELITE or PICA typewheel?  ',$)
	ACCEPT 40,ANS
40	FORMAT(A)
	CALL STR$UPCASE(ANS,ANS)
	IF (ANS.EQ.'E') THEN
	 RPM = 127
	 LPM = 27
	 TPL = 104
	 NLINES = 74
	 NCOLS = 70
	 LPI = 8
	 CPI = 12
	 MAXCOL = 14*CPI
	 I = TERMOUT(TCHAN,INIT,50)
	IF (.NOT.I) CALL LIB$SIGNAL(I)
	ELSE IF (ANS.EQ.'P') THEN
	 RPM = 106
	 LPM = 23
	 TPL = 78
	 NLINES = 60
	 NCOLS = 60
	 LPI = 6
	 CPI = 10
	 MAXCOL = 14*CPI
	 I = TERMOUT(TCHAN,INIT,3)
	IF (.NOT.I) CALL LIB$SIGNAL(I)
	ELSE
	 GOTO 25
	ENDIF
C
50	CONTINUE
	TYPE 60,'left paper margin',LPM
60	FORMAT(' Please enter the ',a,' (default = ',i3,'):  ',$)
	ACCEPT 70,J
70	FORMAT(I)
	IF (J.GT.0) LPM = J
	IF (LPM.GT.MAXCOL) GOTO 50
	TYPE 60,'right paper margin',RPM
	ACCEPT 70,J
	IF (J.GT.0) RPM = J
	IF (LPM.GE.RPM) GOTO 50
	IF (RPM.GT.MAXCOL) GOTO 50
	TYPE 60,'number of printing columns',NCOLS
	ACCEPT 70,J
	IF (J.GT.0) NCOLS = J
	IF (NCOLS.GT.(RPM-LPM)) GOTO 50
C
80	CONTINUE
	TYPE 60,'total paper length',TPL
	ACCEPT 70,J
	IF (J.GT.0) TPL = J
	TYPE 60,'number of printing lines',NLINES
	ACCEPT 70,J
	IF (J.GT.0) NLINES = J
	IF (NLINES.GT.TPL) GOTO 80
C
C	Finally, set up the terminal
C
	TYPE 90
90	FORMAT(' Align paper on printer and type RETURN')
	ACCEPT 40,ANS
C
C	Perform Top-of-Page Alignment
C
	BUF(1) = 27
	BUF(2) = 12
	BUF(3) = TPL
	BUF(4) = 27
	BUF(5) = 11
	BUF(6) = (TPL-LPI-NLINES)/2
	I = TERMOUT(TCHAN,BUF,6)
	IF (.NOT.I) CALL LIB$SIGNAL(I)
C
C	Now, add the hardware tabs & set margins
C
	BUF(1) = 27
	BUF(2) = 9
	BUF(3) = LPM+(RPM-LPM-NCOLS)/2
	BUF(4) = 27
	BUF(5) = 57
	J = 0
	IF (BUF(3)+7.LE.RPM) THEN
	 DO 100 I=BUF(3)+7,RPM,8
	 BUF(6+J) = 27
	 BUF(7+J) = 9
	 IF (I.GE.128) THEN
	  BUF(8+J) = I-256
	 ELSE
	  BUF(8+J) = I
	 ENDIF
	 BUF(9+J) = 27
	 BUF(10+J) = 49
	 J = J+5
100	 CONTINUE
	ENDIF
	BUF(11+J) = 27
	BUF(12+J) = 48
	I = TERMOUT(TCHAN,BUF,12+J)
	IF (.NOT.I) CALL LIB$SIGNAL(I)
C
C	Set up the bottom of page for auto-feeding.
C
	BUF(1) = 27
	BUF(2) = 11
	BUF(3) = NLINES
	BUF(4) = 27
	BUF(5) = 76
	BUF(6) = 13
	BUF(7) = 10
	I = TERMOUT(TCHAN,BUF,7)
	IF (.NOT.I) CALL LIB$SIGNAL(I)
C
C	All done, deassign terminal and get out
C
	I = SYS$DASSGN(%VAL(TCHAN))
	IF (.NOT.I) CALL LIB$SIGNAL(I)
	END
	INTEGER*4 FUNCTION TERMOUT(TCHAN,TEXT,LEN)
C
C	This function outputs to channel 'chan' using the
C	'noformat' mode of the terminal driver.  The data
C	output is in the array TEXT, and is of length LEN.
C
	INTEGER*4 SYS$QIOW
	INTEGER*4 TCHAN,LEN
	BYTE TEXT(LEN)
	EXTERNAL IO$_WRITEVBLK,IO$M_NOFORMAT
C
	IOFUNC = %LOC(IO$_WRITEVBLK) + %LOC(IO$M_NOFORMAT)
	TERMOUT = SYS$QIOW(,%VAL(TCHAN),%VAL(IOFUNC),
	1 ,,,%REF(TEXT),%VAL(LEN),,,,)
	RETURN
	END
