C*****************************************************8
C	THIS PROGRAM WILL PLOT DATA FROM FOR029.dat
C	Essentially it plots weight loss data from a simple file.
C	The file is set up with a 3 digit number per line and
C	ends with "000" as the the last entry.
C	David A. Drake
C	August 13,1981
C*****************************************************
	integer wd(300)
	real rwd(302),rfram(302)
	iw=1
	i=1
50	Format(I3)
	DO WHILE (iw.gt.0)
		Read(29,50) wd(i)
		rwd(i)=float(wd(i))
		rfram(i)=float(i)
C		Type *,'wd,rwd,rfram,i',wd(i),rwd(i),rfram(i),i
		iw=wd(i)
		i=i+1
	END DO
	i=i-2
C	These plotting routines are intended to drive DEC's LPXY-11
C	driving software. It is basically the ISPP standard.
C	Make mods as needed
	CALL SCALE(rwd,10.,i,1)
	CALL SCALE(rfram,8.,i,1)
	CALL PLOTST(.002,'IN',1)
	CALL FACTOR(0.8)
	CALL PLOT(0.5,0.5,-3)
	CALL AXIS(0.,0.,'ELAPSED DAYS ',-13,8.,0.,rfram(i+1),rfram(i+2))
	CALL AXIS(0.,0.,'WEIGHT IN POUNDS',16,10.,90.,rwd(i+1),rwd(i+2))
	CALL PLOT(0.,0.,-3)
	CALL LINE(rfram,rwd,i,1,0,0)
	CALL PLOT(0.,0.,-3)
	wloss=rwd(1)-rwd(i)
	wlave=wloss/i
	ploss=100.*wloss/rwd(1)
	CALL SYMBOL(1.,9.5,0.2,'TOTAL WEIGHT LOSS      LBS. ',0.,28)
	CALL NUMBER(4.,9.5,0.2,WLOSS,0.,0)
	CALL SYMBOL(1.,9.,0.2,'AVERAGE LOSS PER DAY',0.,20)
	CALL NUMBER(5.,9.,0.2,wlave,0.,3)	
	CALL SYMBOL(1.,8.5,.2,'PERCENTAGE LOST',0.,15)
	CALL NUMBER(5.,8.5,.2,ploss,0.,2)
	CALL PLOTND
	CALL EXIT
	END
