$ goto skip_header
$ !
$ !	MRclean.com
$ !
$ !	Procedure to: Drain the BLACK_HOLE queue.
$ !
$ !	Author: M. Erik Husby, March 1981
$ !
$ !	Modifications: To use the black_hole device.
$ !
$ !	Calling sequence: submit/after=tomorrow mrclean
$ !
$ !	Notes: This is a privledged command file, it starts and stops
$ !		queues.
$ !
$ skip_header:
$ set noon
$ !
$ !	Now the fun starts.
$ !	Allocate a black_hole device besides unit 0
$ set noon
$ allocate bh0:
$ set on
$ allocate bh: bh_device:
$ bh_device_name:='f$logical("BH_DEVICE")'
$ deallocate 'bh_device_name'
$ set device/spooled=('bh_device_name',sys$sysdisk) 'bh_device_name'
$ initialize/queue/process=nlsymb/noenable_generic_printing 'bh_device_name'
$ assign/queue 'bh_device_name' black_hole 
$ show queue/all/device/full
$ start/queue 'bh_device_name'
$ start/queue black_hole
$ !
$ !	Now wait for the BLACK_HOLE to swallow everything.
$ wait 00:10:00
$ !
$ !	And then turn it off until tomorrow.
$ stop/queue/next black_hole
$ stop/queue/next 'bh_device_name'
$ deassign/queue black_hole
$ show queue/all/device/full
$ delete/queue 'bh_device_name'
$ set device/nospooled 'bh_device_name'
$ !
$ ! all done:
$ !
$ exit_com: 
$ !
$ !	We will do this again tommorow, same time, same place.
$ submit/after=tomorrow sys$mgr:mrclean
$ define sys$print black_hole
$ exit
